//
//  VideoAppDelegate.m
//  Video
//
//  Created by NYU User on 4/21/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "VideoAppDelegate.h"
#import "View.h"

@implementation VideoAppDelegate
@synthesize window;

#pragma mark -
#pragma mark Application lifecycle

- (BOOL) application: (UIApplication *) application
	didFinishLaunchingWithOptions: (NSDictionary *) launchOptions {    

	// Override point for customization after application launch.
    
	NSBundle *bundle = [NSBundle mainBundle];
	if (bundle == nil) {
		NSLog(@"Could not create bundle.");
		return YES;
	}
	
	NSString *filename =
		[bundle pathForResource: @"Marry me Jane 1944" ofType: @"mp4"];
	if (filename == nil) {
		NSLog(@"could not find file sneeze.m4v");
		return YES;
	}
    
    NSURL *url = [NSURL fileURLWithPath: filename];
	if (url == nil) {
		//NSLog(@"could not create URL for file @%", filename);
        NSLog(@"could not create URL");
		return YES;
	}
	
	controller =
		[[MPMoviePlayerController alloc] init];

	if (controller == nil) {
		NSLog(@"could not create MPMoviePlayerController");
		return YES;
	}

    controller.shouldAutoplay = NO; //don't start spontaneously
	[controller setContentURL: url];
	controller.scalingMode = MPMovieScalingModeNone;
	controller.controlStyle = MPMovieControlStyleFullscreen;
	controller.movieSourceType = MPMovieSourceTypeFile; //vs.stream
    [controller retain];
	
	NSNotificationCenter *center = [NSNotificationCenter defaultCenter];
	
	[center
		addObserver: self
		selector: @selector(playbackDidFinish:)
		name: MPMoviePlayerPlaybackDidFinishNotification
		object: controller
	];

	UIScreen *s = [UIScreen mainScreen];
	view = [[View alloc] initWithFrame: s.applicationFrame];
	window = [[UIWindow alloc] initWithFrame: s.bounds];

	[window addSubview: view];
	[window makeKeyAndVisible];
	return YES;
}

- (void) applicationWillResignActive: (UIApplication *) application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void) applicationDidEnterBackground: (UIApplication *) application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void) applicationWillEnterForeground: (UIApplication *) application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void) applicationDidBecomeActive: (UIApplication *) application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void) applicationWillTerminate: (UIApplication *) application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}

#pragma mark -
#pragma mark Application delegate is target of button.

- (void) touchUpInside: (id) sender {
    NSLog(@"TouchUpInside");
	controller.view.frame = view.frame;
	[view removeFromSuperview];
	[window addSubview: controller.view];
	[controller play];
}

#pragma mark -
#pragma mark Application delegate is observer of MPMoviePlayerController.

- (void) playbackDidFinish: (NSNotification *) notification {
	//notification.object is the controller.
	[controller.view removeFromSuperview];
	[UIApplication sharedApplication].statusBarHidden = NO;
	[window addSubview: view];
}

#pragma mark -
#pragma mark Memory management

- (void) applicationDidReceiveMemoryWarning: (UIApplication *) application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}

@end
